// FileWriter.h: CFileWriter NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "NCachedFile.h"


/////////////////////////////////////////////////////////////////////////////
// ėpt@Co(CMediaDatâ܂܃t@Cɏo)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData		݃f[^
/////////////////////////////////////////////////////////////////////////////
#define FILE_CACHE_SIZE (32*1024)		// TCYƂɁAt@CɏށBlbg[NhCuΉ

class CFileWriter : public CMediaDecoder  
{
public:
	CFileWriter(CDecoderHandler *pDecoderHandler);
	virtual ~CFileWriter();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CFileWriter
	const bool OpenFile(LPCTSTR lpszFileName);
	void CloseFile(void);

	const LONGLONG GetWriteSize(void) const;
	const LONGLONG GetWriteCount(void) const;

protected:
	CNCachedFile m_OutFile;
	
	LONGLONG m_llWriteSize;
	LONGLONG m_llWriteCount;

	DWORD m_CachePtr;
	BYTE* m_abyCache;
};
